#!/bin/bash

function leiturae () 
{
	while read line
	do  
		for i in 1
		do
			entregadores[$j]=`echo $line | cut -d';' -f1`
			j=$((j+1))
		done 	
	done
}

function leiturac ()
{ 
	while read line
	do
		for i in `seq 1 6`
		do
			cardapio[$k]=`echo $line | cut -d';' -f"$i"`
			k=$((k+1))
		done
		echo "`echo $line | cut -d';' -f3 | sed "s/ /\_/g"` R$`echo $line | cut -d';' -f4 ` 'off' " >> item
	done
}

function cadastra ()
{ 
step=name
while : ; 
do
	case "$step" in

		name)
			back=exit
			step=address
			nome=$( dialog 								\
				--stdout --backtitle "Disque-Rango" 	\
				--title 'Cadastro' 						\
				--cancel-label 'Voltar' 				\
				--inputbox 'Nome: ' 					\
				10 30 )
			;;
		address)
			back=name
			step=reference
			end=$( dialog 								\
				--stdout --backtitle "Disque-Rango" 	\
				--title 'Cadastro' 						\
				--cancel-label 'Voltar' 				\
				--inputbox 'Endereço: ' 				\
				0 0 )
			;;
		reference)
			back=address
			step=check
			pref=$( dialog 								\
				--stdout --backtitle "Disque-Rango" 	\
				--title 'Cadastro' 						\
				--cancel-label 'Voltar' 				\
				--inputbox 'Ponto de Referencia: ' 		\
				0 0 )
			;;
		check)
			back=reference
			step=saving
			dialog 									\
			--backtitle "Disque-Rango" 				\
			--title 'Cadastro Realizado com Sucesso'\
			--yesno "
			 Os dados informados foram: 
			
			 Nome : $nome
			 Endereço : $end
			 Ponto de Ref: $pref


			 Confirmar?
			 " 0 0
			;;
		saving)
			echo "$1;$nome;$end;$pref" >> log.lp 
			break
			;;
		exit)
		 	break
			;;			
	esac
	retorno=$?
	[ $retorno -eq 1 ] && step=$back
done
	
}

######################################################################################################################################
################################################## Main body of script starts here ###################################################
######################################################################################################################################
j=0
k=0

#############################################################################
############################# Tratando entrada ##############################
#############################################################################
if [ $# -lt 4 ] 
	then
		echo "Arquivos de entrada não especificados. Use: -e <entregadores> -c <cardápio> "
		exit 1
fi
if [ $1 != "-c" -o $3 != "-e" ] && [ $1 != "-e" -o $3 != "-c" ]
	then
		echo "Arquivos de entrada não especificados. Use: -e <entregadores> -c <cardápio> "
		exit 1
fi
#############################################################################
if [ ! -e $2 ] || [ ! -e $4 ] 
then
	if [ ! -e $2 ]
	then
		echo "Não foi possível processar os arquivos especificados: $2"
	fi
	if [ ! -e $4 ]
	then
		echo "Não foi possível processar os arquivos especificados: $4"
	fi
	exit 1
	
fi
#############################################################################
if [ $1 = "-c" ]
then 
		leiturac < $2
		leiturae < $4
fi
#############################################################################
if [ $1 = "-e" ]
then
		leiturae < $2
		leiturac < $4
fi

function soma ()
{
    tr ' ' '+' <<< "$*" | bc
}

#####################################################################################################
####################################### Interface do Usúario ########################################
#####################################################################################################
proximo=inicio
while : ; 
do
	
	case "$proximo" in

		inicio)
			valor=0
			proximo=decisao
			tel=$( dialog --stdout 								\
				--backtitle 'Disque-Rango'						\
				--title 'Novo Pedido' 							\
				--cancel-label 'Sair' 							\
				--inputbox 'Por favor, confirme o telefone:' 	\
				0 0 )
			[ $? -eq 1 ] && proximo=fim
			;;
		decisao)
			if [ -e log.lp ]
			then
				existe="`grep -w $tel log.lp | tail -1`"
				if [ -n "$existe" ] 
				then
					proximo=recadastro
				else
					proximo=cadastro
				fi
			else
				proximo=cadastro
			fi
			;;
		recadastro)
			proximo=comprar
			anterior=inicio
			dialog --stdout 					\
			--backtitle 'Disque-Rango'			\
			--title 'Novo Pedido' 				\
			--yesno "
			 Confirmar Cadastro? 
			 
			 Nome : `echo $existe | cut -d";" -f2`
			 Endereço : `echo $existe | cut -d";" -f3`
			 Ponto de Ref: `echo $existe | cut -d";" -f4`

			 Confirmar?
			 " 0 0 
			if [ $? -eq 1 ]
			then
				cadastra $tel
			fi
			;;
		cadastro)
			anterior=inicio
			proximo=comprar
			cadastra $tel
			[ $step == 'exit' ] && proximo=inicio
			;;
		comprar)
			anterior=cadastro	
			proximo=inicio
			escolha=$( dialog --stdout				\
				--backtitle 'Disque-Rango'			\
				--title 'Cardapio'					\
				--separate-output					\
				--checklist 'Escolha seu pedido'	\
				0 0 0								\
				$(cat item) )
			if [ ! -z "$escolha" ]
			then
				for linha in $escolha
				do
					qtd=$( dialog --stdout				\
					--backtitle 'Disque-Rango'			\
					--title 'Cardapio'					\
					--inputbox "Quantidade de $linha "	\
   					0 0 )
					if [ ! -z $qtd  ]
					then
						echo "$linha" "$qtd" >> pedidos
						preco=$(tr -d "R$" <<<  `cat item | grep -w $linha | cut -d" " -f2` | sed "s/,/\./g" )
						valor=`echo "$valor + $preco * $qtd" | bc`
					fi
				done
			fi
			dialog 									\
				--backtitle "Disque-Rango" 			\
				--title 'Compra realizada'			\
				--yesno "
				Finalizar o pedido?
				Total da conta é R$ $valor " 0 0 
			[ $? -eq 1 ] && proximo=comprar
			;;
		fim)
			touch temp 
			if [ -e pedidos ]
			then
				while read i 
				do
					qtd=`echo $i | cut -d" " -f2`
					prod=`echo $i | cut -d" " -f1`
					existe="`grep -w "$prod" temp`"
					if [ -z "$existe" ]
					then
						vet="`grep -w $prod pedidos | cut -d" " -f2`"
						pico=`echo $vet | grep "[5-9][0-9]*\|[1-9][0-9]" `
						vet=($vet)	
						total=`soma ${vet[@]}`
						if [ -n "$pico" ]
						then
							echo $prod';'$total';Sim' >> temp
						else
							echo $prod';'$total';Não' >> temp
						fi
					fi
				done < pedidos
				rm pedidos
			fi
			sort -rnk2 -t";" temp | sed "s/_/\ /g" > relatorio.csv
			rm temp item 
			dialog					\
				--backtitle 'Disque-Rango'	\
				--title "Relatorio"		\
				--textbox relatorio.csv		\
				0 0
			break
			;;
	esac
done



